import React, {Component} from 'react'
import css from './index.scss'
import DataUtil from '../../../../util/dateTime'
import Modal from 'react-modal-plugin'
import tost,{errorTost} from "kara-module-tost";
import 'kara-module-tost/lib/index.css'
import emojiConfig from '../../../EmojiConfig/index';

class TxtComponent extends Component{
  constructor(props) {
    super(props)
    this.state = {
      showmodal: false,
      messageId: '',
        height: 'auto'
    }
      this.container = React.createRef()
  }

    componentDidMount() {
        if (this.state.height === 'auto' && this.container.current) {
            this.setState({ height: this.container.current.offsetHeight})
        }
    }
  cancelFavorite = (id,type) => {
    this.props.httpAgent.post(`/webapi/message/favorite/${id}/no`).then(
      res => {
        if(res && res.resultCode && res.resultCode === '000000') {
          tost({type:'success',msg:'取消收藏成功',time:4}) 
          this.props.cancelImFavorite(id, type, this.props.fromPage)
        }
        else {
          tost({type:'error',msg:'取消收藏失败',time:4}) 
        }
      }
    )
  }
  modalShow = (id) => {
    this.setState({showmodal: true})
    this.setState({messageId: id})
  }
  modalHide = () => {
    this.setState({showmodal: false})
  }

    /**
     * 切片函数
     * @param text 文本
     * @param reg 正则
     * @param emit 匹配结果转换器
     * @param next 余下文本切片
     * @returns {*}
     */
    getSlices = (text, reg, emit, next) => {
        const matchs = text.match(reg); // 匹配的结果 进行相关替换
        if(matchs === null) {
            // 没有匹配
            return next ? next(text) : text; // 没有匹配继续下一个切片
        }
        const slices = text.split(reg); // 切片后的文本 继续下一个切片
        let items = []
        for (let i=0; i<slices.length; i++) {
            const ele = <span key={i}>{next ? next(slices[i]) : slices[i]}{emit ? emit(matchs[i]): matchs[i]}</span>
            const children = ele.props.children
            items = items.concat(children)
        }
        return items;
    }

    getEmojis = (text) => {
        const reg = /:\S*?:|\[\S*?\]/g;
        return this.getSlices(text, reg, this.getEmoji, this.getMentions)
    }
    getEmoji = (text) => {
        // :small: [微笑]
        for (const i of emojiConfig) {
            const {size, data} = i
            if (data[text]) {
                return <img className={css[size]} src={data[text]} alt=''/>
            }
        }
        return text
    }

    // 换行解析
    getNewLines = (text) => {
        const reg = /\n/g;
        const emit = (t) => {
            return t ? <br /> : null
        }
        return this.getSlices(text, reg, emit)
    }

    // mention @ 解析
    getMentions = (text) => {
        const reg = /<@[^<(?=@)]+?\|.+?>/g;
        return this.getSlices(text, reg, this.getMention, this.getNewLines)
    }
    getMention = (text) => {
        // <@account|name>
        if (!text) {
            return null
        }
        const res = /<@([^<(?=@)]+?)\|(.+?)>/g.exec(text);
        if (!res) {
            return null
        }
        const account = res[1];
        const name = res[2];
        return account && name ? <span className={css.mention}>@{name === 'all' ? '所有人' : name}</span> : null
    }
  render(){
    const {lang,karaui:{Forward}} = this.props
    let fileAttr = this.props.fileAttr
    return (<div ref={this.container} className={`s-b-secondary ${css.txtContainer}`} style={{height: fileAttr.canceled ? 0 : this.state.height}}>
              <ul className={css.txtItem}>
                <li>
                  <div>
                    <p>{this.getEmojis(fileAttr.text)}</p>
                  </div>
                </li>
                <li className='s-hint'>
                  <span>{lang.source}&nbsp;{fileAttr.fromUserName}</span>
                  <span>{DataUtil.DateShow(fileAttr.ts)}</span>
                  <span className={css.hoverShow} onClick={()=>{this.modalShow(fileAttr.messageId)}}><i className='kuc-iconfont kuc-forward'></i>&nbsp;{lang.forward}</span>
                  <span className={css.hoverShow} onClick={()=>{this.cancelFavorite(fileAttr.id,fileAttr.favoriteType)}}><i className='kuc-iconfont kuc-favorite s-primary'></i>&nbsp;取消收藏</span>
                </li>
              </ul>
              <Modal show={this.state.showmodal} onMask={this.modalHide}>
                <Forward httpAgent={this.props.httpAgent} modalHidden={this.modalHide} messageId={this.state.messageId} />
              </Modal>
            </div>
            )
  }
}

export default TxtComponent
