import React, {Component} from 'react'
import {inject, observer} from "mobx-react"
import css from './index.scss'
import UCInfo from '../UCInfo/index'
import UCIntegral from '../UCIntegral/index'
import UCHoliday from '../UCHoliday/index'
import UCFavorite from '../UCFavorite/index'
import {en, zh} from '../../assets/language/language'


@inject('UCNavStore', 'ConfigStore')
@observer
class KaraUC extends Component{
  constructor(props) {
    super(props)
    this.contentRef = React.createRef()
    this.state = {
      showModal: false,
    }
    console.log(props)
    this.lang = props.ConfigStore.config.language === 'en' ? en : zh
  }
  selectTab = (index) => {
    if(this.props.UCNavStore.activeTab != index){
        this.props.UCNavStore.setActiveTab(index)
    }
  }
  loadComponet() {
    const {UCNavStore} = this.props
    if(UCNavStore.activeTab === 0){
      return <UCInfo lang={this.lang} />
    }
    else if (UCNavStore.activeTab === 1) {
      return <UCFavorite contentRef={this.contentRef} lang={this.lang} />
    }
    else if (UCNavStore.activeTab === 2) {
      return <UCIntegral lang={this.lang} />
    }
    else if (UCNavStore.activeTab === 3) {
      return <UCHoliday lang={this.lang} />
    }
  }
  render(){
    const { lang } = this
    const {UCNavStore} = this.props
    return (
      <div className={css.KaraUC} ref={this.contentRef}>
        <ul className="s-bg-container">
          <li className={UCNavStore.activeTab === 0 ? 's-bg-menu active' : ''} onClick={()=>{this.selectTab(0)}}> 
            <i className='kuc-iconfont kuc-user s-primary'></i>{lang.userInfo}
          </li>
          <li className={UCNavStore.activeTab === 1 ? 's-bg-menu active' : ''} onClick={()=>{this.selectTab(1)}}> 
            <i className='kuc-iconfont kuc-collect s-primary'></i>{lang.myCollect}
          </li>
          <li className={UCNavStore.activeTab === 2 ? 's-bg-menu active' : ''} onClick={()=>{this.selectTab(2)}}> 
            <i className='kuc-iconfont kuc-score s-primary'></i>{lang.myScore}
          </li>
          {/* <li className={UCNavStore.activeTab === 3 ? 's-bg-menu active' : ''} onClick={()=>{this.selectTab(3)}}>  
            <i className='kuc-iconfont kuc-holiday s-primary'></i>我的休假
          </li> */}
        </ul>
        <div className={`s-bg-container ${css.content}`}>
         {this.loadComponet()}
        </div>
      </div>
    )
  }
}

export default KaraUC
